image: registry.gitlab.com/yakshaving.art/dockerfiles/go-builder:latest
stages:
  - build
  - image
  - release

variables:
  CGO_ENABLED: 0
  GOCACHE: ${CI_PROJECT_DIR}/.cache/go-build

cache:
  key: build-cache
  paths:
  - vendor
  - .cache/go-build

build-binary:
  stage: build
  coverage: '/^total:\s+\(statements\)\s+(\d+.\d+)%$/'
  artifacts:
    paths:
    - chief-alert-executor-*
  script:
  - make test
  - bash .gitlab.d/ci/build_binaries.sh

.build-image: &build-image
  image:
    name: registry.gitlab.com/yakshaving.art/kaniko-multiarch:latest
  stage: release
  before_script:
  - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json 
  after_script:
  - rm /kaniko/.docker/config.json

release_build:
  <<: *build-image
  script:
  - /bin/sh .gitlab.d/ci/release_docker_kaniko.sh ${CI_COMMIT_SHORT_SHA}
  except:
  - master

release_latest:
  <<: *build-image
  script:
  - /bin/sh .gitlab.d/ci/release_docker_kaniko.sh latest
  only:
  - master

release_tag:
  <<: *build-image
  script:
  - /bin/sh .gitlab.d/ci/release_docker.sh ${CI_COMMIT_TAG}
  only:
  - tags
